# WiFiPCRemote
ESP8266 based WiFi connected remote control for PC power and reset button with status feedback. Controllable via Web, HTTP-API and MQTT. 

Developed as a more reliable alternative to Wake-on-LAN with extra features such as force Power-Off and status feedback. 
WoL is unreliable in my experience. When the PC has been cut from power, it does not work at all. 

A simple solution would be connecting the PC power cable to a WiFi-Socket, but this has some disadvantages. Therefore the Restore Power State BIOS setting has to be set to Always On. This could lead to the PC running unintendedly for a longer time after a power outage. In addition to that, it can lead to data loss if the PC is in cut from power while being in sleep mode. 

So i decided to build a PC remote control based on the ESP8266 MCU. 
The module is powered either from the +5VSB line of the ATX PSU, from a standby powered USB port, or from an external power supply. 
Connections to the PC hardware a simple - only some transistors and resistors. 

The module itself can either be built directly inside the PC case or as an external module. I prefered the latter in order to have no issues with WiFi connectivity. I used a slot bracket with DSUB 9 pin connector (female version to avoid it being mistaken as a RS-232 port) and added a cable with suitable connector to the module. 

### Functions
- remote control a PC by actuating its power and reset button
- detection of PC´s status (on, sleep, off) by observing the power LED output (on motherboards that blink the power LED when in sleep)
- perform short press (Power On/Sleep) and hold (Force Power Off) on the POWER switch
- perform reset switch action
- controllable and status reporting via web interface, HTTP-API and MQTT
- directly supports Home Assistant MQTT switch and sensor devices, so that Home Assistant can easily be set up as the frontend
- WiFi setup with captive portal
- fully configurable via web interface
- OTA Firmware Update

### Connections
- power supply: either from ATX PSUs +5VSB line, an USB port with +5VSB supply or an external power adapter
- motherboard terminals: POWER switch, RESET switch and POWER-LED
