void httpServerHandleMainPage() {
  httpServerSendHtmlHeadChunked();
  httpServer.sendContent_P(html_main_script);
  httpServer.sendContent_P(html_head_end);
  httpServer.sendContent_P(html_bodytag_jsinit);
  httpServerSendHtmlBodyPageheadChunked();
  httpServer.sendContent_P(html_main_body);
  if (httpIsAuthenticatedAdmin()) httpServer.sendContent_P(html_main_body_adminonly);
  httpServer.sendContent_P(html_main_body2);
  httpServerSendHtmlFooterChunked();
}

void httpServerHandleConfPage() {
  httpServerSendHtmlHeadChunked();
  httpServer.sendContent_P(html_head_end);
  httpServer.sendContent_P(html_bodytag);
  httpServerSendHtmlBodyPageheadChunked();
  httpServer.sendContent_P(html_conf_body);
  httpServerSendHtmlFooterChunked();
}

void httpServerHandleConfWebPage() {
  httpServerSendHtmlHeadChunked();
  httpServer.sendContent_P(html_confweb_script);
  httpServer.sendContent_P(html_head_end);
  httpServer.sendContent_P(html_bodytag_jsinit);
  httpServerSendHtmlBodyPageheadChunked();
  httpServer.sendContent_P(html_confweb_body);
  httpServerSendHtmlFooterChunked();
}

void httpServerHandleConfMqttPage() {
  //httpServer.send_P(200, "text/html", httpConfPage);
  httpServerSendHtmlHeadChunked();
  httpServer.sendContent_P(html_confmqtt_script);
  httpServer.sendContent_P(html_head_end);
  httpServer.sendContent_P(html_bodytag_jsinit);
  httpServerSendHtmlBodyPageheadChunked();
  httpServer.sendContent_P(html_confmqtt_body);
  httpServerSendHtmlFooterChunked();
}

void httpServerHandleConfSavedPage() {
  httpServerSendHtmlHeadChunked();
  httpServer.sendContent_P(html_head_end);
  httpServer.sendContent_P(html_bodytag);
  httpServerSendHtmlBodyPageheadChunked();
  httpServer.sendContent_P(html_confsaved_body);
  httpServerSendHtmlFooterChunked();
}

void httpServerHandleRestartPage() {
  httpServerSendHtmlHeadChunked();
  httpServer.sendContent_P(html_head_end);
  httpServer.sendContent_P(html_bodytag);
  httpServerSendHtmlBodyPageheadChunked();
  httpServer.sendContent_P(html_restarting_body);
  httpServerSendHtmlFooterChunked();
}

void httpServerHandleClearconfPage() {
  httpServerSendHtmlHeadChunked();
  httpServer.sendContent_P(html_head_end);
  httpServer.sendContent_P(html_bodytag);
  httpServerSendHtmlBodyPageheadChunked();
  httpServer.sendContent_P(html_clearconf_body);
  httpServerSendHtmlFooterChunked();
}

void httpServerSendHtmlHeadChunked() {
  httpServer.setContentLength(CONTENT_LENGTH_UNKNOWN);   //Enable Chunked Transfer
  httpServer.send(200, "text/html", html_head_part1);
  httpServer.sendContent(FIRMWARE_NAME);
  httpServer.sendContent(" - ");
  httpServer.sendContent(deviceName);
  httpServer.sendContent_P(html_head_part2);
}

void httpServerSendHtmlBodyPageheadChunked() {
  httpServer.sendContent_P(html_body_pagehead_part1);
  httpServer.sendContent(FIRMWARE_NAME);
  httpServer.sendContent(" - ");
  httpServer.sendContent(deviceName);
  httpServer.sendContent_P(html_body_pagehead_part2);
}

void httpServerSendHtmlFooterChunked() {
  httpServer.sendContent_P(html_footer1);
  httpServer.sendContent("<a href='");
  httpServer.sendContent(FIRMWARE_URL);
  httpServer.sendContent("' target='_blank' style='color:#AAA;'>");
  httpServer.sendContent(FIRMWARE_NAME);
  httpServer.sendContent("</a> v");
  httpServer.sendContent(FIRMWARE_VERSION);
  httpServer.sendContent(" by <a href='");
  httpServer.sendContent(FIRMWARE_COPYRIGHT_URL);
  httpServer.sendContent("' target='_blank' style='color:#AAA;'>");
  httpServer.sendContent(FIRMWARE_COPYRIGHT);
  httpServer.sendContent("</a>");
  httpServer.sendContent_P(html_footer2);
  httpServer.sendContent("");
  httpServer.client().stop();
}

boolean httpIsAuthenticated() {
  if (http_user_auth) {
    boolean useAuth = false;
    boolean isAuthenticated = false;
    if ((strlen(http_user) > 0 && strlen(http_pass) > 0) || (strlen(http_user1) > 0 && strlen(http_pass1) > 0) || (strlen(http_user2) > 0 && strlen(http_pass2) > 0)) useAuth = true;
    if (useAuth) {
      if ((strlen(http_user) > 0 && strlen(http_pass) > 0)) {
        if (httpServer.authenticate(http_user, http_pass)) isAuthenticated = true;
      }
      if ((strlen(http_user1) > 0 && strlen(http_pass1) > 0)) {
        if (httpServer.authenticate(http_user, http_pass)) isAuthenticated = true;
      }
      if ((strlen(http_user2) > 0 && strlen(http_pass2) > 0)) {
        if (httpServer.authenticate(http_user2, http_pass2)) isAuthenticated = true;
      }
      return isAuthenticated;
    }
    else return true;
  }
  else return true;
}

boolean httpIsAuthenticatedAdmin() {
  boolean auth = false;
  if ((strlen(http_user) > 0 && strlen(http_pass) > 0)) auth = true;
  if (auth) {
    if (!httpServer.authenticate(http_user, http_pass)) return false;
    else return true;
  }
  else return true;
}

void httpServerHandleNotFound() {
  httpServer.send(404, "text/plain", "404 NOT FOUND");
}

void httpSendUnauthorized() {
  httpServer.send (401, "text/plain", "UNAUTHORIZED");
}

void httpSend200OK() {
  httpServer.send (200, "text/plain", "OK");
}

boolean httpCheckToken() {
  if (http_token[0] != '\0') { // dont accept empty token
    if (httpServer.hasArg("token")) {
      char buf[20];
      httpServer.arg("token").toCharArray(buf, 20);
      if (strcmp(buf, http_token) == 0) return true;
      else return false;
    }
    else return false;
  }
  else return false;
}


void httpServerInit() {
  httpServer.on("/style.css", []() {
    httpServer.sendHeader("cache-control", "max-age=86400", false);
    httpServer.send_P(200, "text/css", html_stylesheet);
  });
  httpServer.on("/api", []() {
    if ( httpIsAuthenticated() || (!httpIsAuthenticated() && httpCheckToken()) ) {
      //Serial.println("httpServer.on /api");
      if (httpServer.hasArg("BtnPwr")) {
        Serial.println("web BtnPwr");
        PC_pwrSwitchShort();
      }
      if (httpServer.hasArg("BtnPwrH")) {
        Serial.println("web BtnPwrH");
        PC_pwrSwitchHold();
      }
      if (httpServer.hasArg("BtnRes")) {
        Serial.println("web BtnRes");
        PC_resSwitch();
      }
      yield();

      StaticJsonBuffer<300> jsonBuffer;
      JsonObject &json = jsonBuffer.createObject();
      json["ssid"] = WiFi.SSID();
      json["devname"] = deviceName;
      json["uptime"] = uptimeStr;
      json["freeheap"] = ESP.getFreeHeap();

      if (mqttclient.state() == -4) json["mqttstate"] = "CONNECTION_TIMEOUT";
      else if (mqttclient.state() == -3) json["mqttstate"] = "CONNECTION_LOST";
      else if (mqttclient.state() == -2) json["mqttstate"] = "CONNECT_FAILED";
      else if (mqttclient.state() == -1) json["mqttstate"] = "DISCONNECTED";
      else if (mqttclient.state() == 0) json["mqttstate"] = "CONNECTED";
      else if (mqttclient.state() == 1) json["mqttstate"] = "CONNECT_BAD_PROTOCOL";
      else if (mqttclient.state() == 2) json["mqttstate"] = "CONNECT_BAD_CLIENT_ID";
      else if (mqttclient.state() == 3) json["mqttstate"] = "CONNECT_UNAVAILABLE";
      else if (mqttclient.state() == 4) json["mqttstate"] = "CONNECT_BAD_CREDENTIALS";
      else if (mqttclient.state() == 5) json["mqttstate"] = "CONNECT_UNAUTHORIZED";

      json["mqtthost"] = mqtt_server;
      json["mqttreconn"] = mqttReconnects - 1;

      if (PCstate == 0) json["PCstate"] = "OFF";
      else if (PCstate == 1) json["PCstate"] = "ON";
      else if (PCstate == 2) json["PCstate"] = "SLEEP";
      else json["PCstate"] = "unknown";

      yield();
      char jsonchar[200];
      json.printTo(jsonchar); //print to char array, takes more memory but sends in one piece
      httpServer.send(200, "application/json", jsonchar);
    }
    else {
      httpSendUnauthorized();
    }
  }); //httpServer.on /api

  httpServer.on("/confdweb", []() {
    if (!httpIsAuthenticatedAdmin()) httpSendUnauthorized();
    else {
      Serial.println("httpServer.on /confdata");
      StaticJsonBuffer<1000> jsonBuffer;
      JsonObject &json = jsonBuffer.createObject();
      json["devName"] = deviceName;
      json["apiToken"] = http_token;
      json["httpUA"] =  http_user;
      //json["httpPA"] =  http_pass;

      if (http_user_auth) json["httpAuth"] = 1;
      else json["httpAuth"] = 0;

      json["httpU1"] =  http_user1;
      //json["httpP1"] =  http_pass1;
      json["httpU2"] =  http_user2;
      //json["httpP2"] =  http_pass2;
      yield();

      char jsonchar[1000];
      json.printTo(jsonchar); //print to char array, takes more memory but sends in one piece
      httpServer.send(200, "application/json", jsonchar);
    }
  }); //httpServer.on /confdweb

  httpServer.on("/confdmqtt", []() {
    if (!httpIsAuthenticatedAdmin()) httpSendUnauthorized();
    else {
      Serial.println("httpServer.on /confdata");
      StaticJsonBuffer<1000> jsonBuffer;
      JsonObject &json = jsonBuffer.createObject();

      if (mqtt_enable) json["mqttEnable"] = 1;
      else json["mqttEnable"] = 0;

      json["mqttHost"] = mqtt_server;
      json["mqttPort"] = mqtt_port;
      json["mqttUser"] =  mqtt_user;
      //json["mqttPass"] =  mqtt_pass;
      json["inTop"] = mqtt_topic_in;
      json["outTop"] = mqtt_topic_out;

      if (mqtt_outRetain) json["outRet"] = 1;
      else json["outRet"] = 0;

      json["willTop"] = mqtt_willTopic;
      json["willQos"] = mqtt_willQos;

      if (mqtt_willRetain) json["willRet"] = 1;
      else json["willRet"] = 0;

      json["willMsg"] = mqtt_willMsg;
      json["connMsg"] = mqtt_connMsg;

      if (mqtt_enable_heartbeat) json["hbEnable"] = 1;
      else json["hbEnable"] = 0;

      json["hbReconn"] = mqtt_heartbeat_maxage_reconnect / 60000;
      json["hbReboot"] = mqtt_heartbeat_maxage_reboot / 60000;

      yield();

      char jsonchar[1000];
      json.printTo(jsonchar); //print to char array, takes more memory but sends in one piece
      httpServer.send(200, "application/json", jsonchar);
    }
  }); //httpServer.on /confdmqtt

  httpServer.on("/setConfWeb", []() {
    if (!httpIsAuthenticatedAdmin()) httpSendUnauthorized();
    else {
      Serial.println("httpServer.on /setConfWeb");
      bool httpPASet, httpP1Set, httpP2Set;
      httpPASet = false;
      httpP1Set = false;
      httpP2Set = false;
      if (httpServer.hasArg("httpPASet")) httpPASet = true;
      if (httpServer.hasArg("httpP1Set")) httpP1Set = true;
      if (httpServer.hasArg("httpP2Set")) httpP2Set = true;

      for (int i = 0; i < httpServer.args(); i++) {
        char bufName[20];
        char bufValue[101];
        httpServer.argName(i).toCharArray(bufName, 20);
        httpServer.arg(i).toCharArray(bufValue, 101);

        if (strlen(bufName) > 0) {
          Serial.print("web update ");
          Serial.print(bufName);
          Serial.print(" = ");
          Serial.println(bufValue);

          if (strcmp(bufName, "httpUA") == 0 || strcmp(bufName, "httpPA") == 0) {
            if (httpPASet) setConfig(bufName, bufValue);
          }
          else if (strcmp(bufName, "httpU1") == 0 || strcmp(bufName, "httpP1") == 0) {
            if (httpP1Set) setConfig(bufName, bufValue);
          }
          else if (strcmp(bufName, "httpU2") == 0 || strcmp(bufName, "httpP2") == 0) {
            if (httpP2Set) setConfig(bufName, bufValue);
          }
          else if (strcmp(bufName, "httpPASet") != 0 && strcmp(bufName, "httpP1Set") != 0 && strcmp(bufName, "httpP2Set") != 0) setConfig(bufName, bufValue);
          //else setConfig(bufName, bufValue);
        }
        //saveConfigWebToFlash = true; // will be saved in next loop()
        //Serial.println("web triggered saveConfigWebToFlash");
      }
      yield();
      saveConfigWeb();

      httpServerHandleConfSavedPage();

      yield();
      ESP.restart();
    }
  }); //httpServer.on /setConfWeb

  httpServer.on("/setConfMqtt", []() {
    if (!httpIsAuthenticatedAdmin()) httpSendUnauthorized();
    else {
      Serial.println("httpServer.on /setConfMqtt");
      bool mqttPassSet;
      mqttPassSet = false;
      if (httpServer.hasArg("mqttPassSet")) mqttPassSet = true;

      for (int i = 0; i < httpServer.args(); i++) {
        char bufName[20];
        char bufValue[101];
        httpServer.argName(i).toCharArray(bufName, 20);
        httpServer.arg(i).toCharArray(bufValue, 101);

        if (strlen(bufName) > 0) {
          Serial.print("web update ");
          Serial.print(bufName);
          Serial.print(" = ");
          Serial.println(bufValue);

          if (strcmp(bufName, "mqttUser") == 0 || strcmp(bufName, "mqttPass") == 0) {
            if (mqttPassSet) setConfig(bufName, bufValue);
          }
          else setConfig(bufName, bufValue);
        }
        //saveConfigMqttToFlash = true; // will be saved in next loop()
        //Serial.println("web triggered saveConfigMqttToFlash");
      }
      yield();
      saveConfigMqtt();

      httpServerHandleConfSavedPage();

      yield();
      ESP.restart();
    }
  }); //httpServer.on /setConfMqtt

  httpServer.on("/", []() {
    if (httpServer.hasArg("restart")) {
      if (httpIsAuthenticated() || (!httpIsAuthenticated() && httpCheckToken()) ) {
        httpServerHandleRestartPage();

        yield();
        delay(5);
        ESP.restart();
      }
      else httpSendUnauthorized();
    }
    else if (httpServer.hasArg("mqttReconnect")) {
      if ( httpIsAuthenticated() || (!httpIsAuthenticated() && httpCheckToken()) ) {
        //Serial.println("web triggered mqttReconnect");
        mqttReconnect();
        httpServer.sendHeader("Location", "/", true);
        httpServer.send(303);
      }
      else httpSendUnauthorized();
    }
    else if (httpServer.hasArg("clearconf")) {
      if (httpIsAuthenticatedAdmin() || (!httpIsAuthenticatedAdmin() && httpCheckToken()) ) {
        httpServerHandleClearconfPage();

        yield();
        delay(5);
        deleteConfig();
      }
      else httpSendUnauthorized();
    }
    else if (!httpIsAuthenticated()) return httpServer.requestAuthentication();
    else {
      httpServerHandleMainPage();
    }
  });

  httpServer.on("/conf", []() {
    if (!httpIsAuthenticatedAdmin()) return httpServer.requestAuthentication();
    else {
      httpServerHandleConfPage();
    }
  });

  httpServer.on("/confweb", []() {
    if (!httpIsAuthenticatedAdmin()) return httpServer.requestAuthentication();
    else {
      httpServerHandleConfWebPage();
    }
  });

  httpServer.on("/confmqtt", []() {
    if (!httpIsAuthenticatedAdmin()) return httpServer.requestAuthentication();
    else {
      httpServerHandleConfMqttPage();
    }
  });

  httpServer.onNotFound([]() {
    httpServerHandleNotFound();
  }); //httpServer.onNotFound


  // HTTP Updater at /update
  httpUpdater.setup(&httpServer, "/update", http_user, http_pass);

  httpServer.begin();
}
